#!/usr/bin/python
# -*- coding: utf-8 -*-

###########################################
# IMPORT LIBRARY
###########################################

import scipy as sc
import numpy as np
from scipy import linalg as LS
from numpy import linalg as LA
from scipy.sparse.linalg import *
import matplotlib.pyplot as plt
from Matrices import *
from Diffusion import *

###############################################################
# Le but de ce TP est de vérifier numériquement la formule 
# de perturbation au premier ordre des valeurs propres 
##############################################################


##########################################################
# N: nombre de fonctions de base dans chaque direction
##########################################################
N = 40;

#On construit les vecteurs associés aux coefficients de diffusion c0 et cp
C = Cmat0(N);
Cper = Cmatper(N); 

#On visualise la valeur du coefficient de diffusion c0
Cmat = convertToMat2(C,N); 
plt.matshow(Cmat); 
plt.show();
 

#On construit les matrices de discrétisation dont on va avoir besoin
C0 = np.ones(N*N); 

# K0 est la matrice associée à la forme bilinéaire a_0(.,.)
K0 = ## TO COMPLETE ##

# B est la matrice associée à la forme bilinéaire associée à b(.,.)
B = ## TO COMPLETE ##

# O est la matrice de masse associé au produit scalaire <.,.>_{L2} 
M = ## TO COMPLETE ##

#On commence par résoudre le problème de référence pour delta=0
[eigval0, eigvec0] = LS.eigh(K,M,type=1); 

lambda0  = eigval0[0];

print "lambda10 = "
print lambda0


#On visualise le vecteur propre associé à la première valeur propre
U = eigvec0[:,0]; 
Umat = convertToMat(U,N); 
plt.matshow(Umat); 
plt.show();


##################################################################################
# A DECOMMENTER POUR LA QUESTION 7
##################################################################################
##On construit des tableaux pour contenir les valeurs de delta et des dérivées approchées
##qu'on calcule par différences finies pour différentes valeurs de delta
#deltatab = []; 
#derivtab= []
#
#delta = 0.1; 
#
#for it in range(0,5):
#
#	print "delta = "
#	print delta; 
#
#	#Kdelta est la matrice associée à la forme bilinéaire a_delta(.,.)
#	Kdelta = ## TO COMPLETE ##
#	[eigval, eigvec]  = LS.eigh(Kdelta,M, type=1); 
#
#	lambdadelta = eigval[0]; 
#	print "lambdadelta = "
#	print lambdadelta
#
#	lambdader = ## TO COMPLETE ##
#
#	print "Derivee approchee = "
#	print lambdader
#	
#	deltatab.append(delta); 
#	derivtab.append(lambdader); 
#
#	delta = delta/10; 
#
#
##On trace les résultats obtenus
#print "Derivees approchees = " 
#print derivtab
#
#plt.plot(log(deltatab)/log(10), derivtab); 
#plt.show(); 
#
####################################################################################




######################################################################################
# A DECOMMENTER POUR LA QUESTION 8
######################################################################################
##On compare avec la formule analytique obtenue à l'exercice
#
#  ## TO COMPLETE ##
#
#lambdaderiv_true = ## TO COMPLETE ## 
#
#print "Formule analytique pour la derivee = "
#print lambdaderiv_true
#
#
##On calcule les erreurs commises par les formules approchées et on les trace en fonction de delta
#errtab = [];  
#
#for it in range(0,5):
#	err = abs(lambdaderiv_true - derivtab[it]); 
#
#	errtab.append(err); 
#
#plt.plot(log(deltatab)/log(10), log(errtab)/log(10)); 
#plt.show();
#
##########################################################################################




