#!/usr/bin/python
# -*- coding: utf-8 -*-

###########################################
# IMPORT LIBRARY
###########################################

import numpy as np
from numpy import linalg as LA
#import matplotlib.pyplot as plt


#Retourne l'indice de la case m en fonction des indices (i,j) (0 <= i,j <= N-1) 
def getNumCase(i,j,N) :
   return i*N+j;


'''
Définit la valeur du coefficient de diffusion c(x,y)
'''
#Fonction qui renvoie la valeur du coefficient de diffusion c0(x,y) en un point (x,y) dans (0,1)^2
def coeff0(x,y) :

	c = 1; 
	if ((abs(x-0.5)<0.25) & (abs(y-0.5)<0.25)): 
		c = 3;
	if ((abs(x-0.125)<0.125)): 
		c = 2; 
	return c;


#Fonction qui renvoie un vecteur de taille N*N qui contient la valeur de la fonction c0(x,y) dans chaque case (i,j) 
def Cmat0(N) :
	C = np.zeros(N*N);

	dx = 1.0/N; 
	for i in range(0,N): 
		for j in range(0,N): 
			C[getNumCase(i,j,N)] = coeff0((i+0.5)*dx, (j+0.5)*dx); 

	return C;   

#Fonction qui renvoie la valeur du coefficient de diffusion de perturbation cp(x,y) en un point (x,y) dans (0,1)^2
def coeffper(x,y) :

	c = 0; 
	if ((abs(x-0.5)<0.25) & (abs(y-0.5)<0.25)): 
		c = 1;
	return c;


#Fonction qui renvoie un vecteur de taille N*N qui contient la valeur de la fonction cp(x,y) dans chaque case (i,j) 
def Cmatper(N) :
	C = np.zeros(N*N);

	dx = 1.0/N; 
	for i in range(0,N): 
		for j in range(0,N): 
			C[getNumCase(i,j,N)] = coeffper((i+0.5)*dx, (j+0.5)*dx); 

	return C; 
