#!/usr/bin/python
# -*- coding: utf-8 -*-

###########################################
# IMPORT LIBRARY
###########################################

import numpy as np
from numpy import linalg as LA
#import matplotlib.pyplot as plt

################################################################
#
# Définition du coefficient de diffusion c(x)
#
#################################################################


#Fonction qui renvoie la valeur du coefficient de diffusion c(x) en un point (x) dans (0,1)
def coeff0(x) :

	c = 1; 
	if ((abs(x-0.25)<=0.125)): 
		c = 3;
	if ((abs(x-0.875)<=0.125)): 
		c = 2; 
	return c


#Fonction qui renvoie un vecteur de taille N qui contient la valeur de la fonction c(x) dans chaque case (x_{i-1}, x_i) pour 1<= i <=N 
def Cmat0(N) :
	C = np.zeros(N);

	dx = 1.0/N; 
	for i in range(0,N): 
			C[i] = coeff0((i+0.5)*dx); 

	return C;   
