#!/usr/bin/python
# -*- coding: utf-8 -*-

###########################################
# IMPORT LIBRARY
###########################################

import scipy as sc
import numpy as np
from scipy import linalg as LS
from numpy import linalg as LA
import matplotlib.pyplot as plt
from Matrices import *
from Diffusion import *
#from Fockmat import *
#from Hartreemat import *

###############################################################
# Le but de ce script est d'observer numériquement les vitesses de convergence
# des valeurs propres et des vecteurs propres données dans le cours 
# en fonction de la taille de la grille de discrétisation éléments finis.
##############################################################


# Calcul de référence: effectué avec un très grand nombre d'intervalles de discrétisation
#
# Nref: nombre d'intervalles de la discrétisation pour le calcul de référence
#
# On charge les données obtenues par resolution_2_ref.py
Nref = 2048;

eigval10ref = np.load('eigvals_ref.npy'); 
eigvec10ref = np.load('eigvects_ref.npy');

# On charge la première valeur propre et le vecteur propre associé
Uref = eigvec10ref[:,0:1];
lambref = eigval10ref[0]; 

# On crée les matrices qui seront utilisées pour le calcul des erreurs L2 et H1 sur la grille de référence 
C0ref = np.ones(Nref);
Mref = ## TO COMPLETE ##
Dref = ## TO COMPLETE ##


# On crée les tableaux qui seront utilisés pour stocker les valeurs des erreurs pour les différentes discrétisations
Ntab = []; 
erreigtab = []; 
errL2tab = []; 
errH1tab = []; 


#On initialise la première valeur de N
N = 16;


for it in range(0,7):

	print "N = "
	print N

	# On calcule les matrices discrétisées associées à a(.,.) et <.,.> pour la discrétisation en N intervalles
	C = Cmat0(N); 
	K = ## TO COMPLETE ##
	
	C0 = np.ones(N); 
	M = ## TO COMPLETE ##
	
	[eig, vect] = ## TO COMPLETE ##
	
	#On récupère la valeur propre et le vecteur propre défini sur la grille grossière
	lamb = eig[0]
	U = vect[:,0:1]; 
	
	print "lambda = "
	print lamb

	# On convertit le vecteur propre en une fonction définie sur la grille fine
	W = convert(U,N,Nref); 
	
	# Calcul de l'erreur L2 (au carré) entre le vecteur propre et le vecteur de référence  
	diff = W - Uref; 
	diff2 = W + Uref; 
	
	 ## TO COMPLETE ##
	
	errL2 = ## TO COMPLETE ##
	
	print "L2 error = "
	print errL2
	
	# Calcul de l'erreur H1 (au carré) entre le vecteur propre et le vecteur de référence
	
	 ## TO COMPLETE ##
	
	errH1 = ## TO COMPLETE ##
	
	print "errH1 = " 	
	print errH1 
	
	# Calul de l'erreur entre la valeur propre et la valeur propre de référence
	erreig = ## TO COMPLETE ##
	
	print "erreig = "
	print erreig
	
	#Stockage des erreurs dans des tableaux
	Ntab.append(N); 
	erreigtab.append(erreig); 
	errL2tab.append(errL2[0,0]); 
	errH1tab.append(errH1[0,0]); 

	N = 2*N; 


plt.plot(np.log(Ntab)/np.log(2) , np.log(erreigtab)/np.log(2), label="erreur sur la valeur propre") 
plt.plot(np.log(Ntab)/np.log(2) , np.log(errL2tab)/np.log(2), label = "erreur L2 (au carre) sur le vecteur propre") 
plt.plot(np.log(Ntab)/np.log(2) , np.log(errH1tab)/np.log(2), label = "erreur H1 (au carre) sur le vecteur propre")
plt.legend()
plt.xlabel('p'); 
plt.ylabel('log erreur'); 
plt.show()
	





