#!/usr/bin/python
# -*- coding: utf-8 -*-

###########################################
# IMPORT LIBRARY
###########################################

import scipy as sc
import numpy as np
from scipy import linalg as LS
from numpy import linalg as LA
import matplotlib.pyplot as plt
from Matrices import *
from Diffusion import *
#from Fockmat import *
#from Hartreemat import *

###############################################################
# Le but de ce script est de résoudre le problème aux valeurs propres 
# pour une grille de discrétisation très fine, pour obtenir un calcul de référence 
# auquel on pourra comparer les erreurs dans la suite du TP
##############################################################


# Calcul de référence: effectué avec un très grand nombre d'intervalles de discrétisation
#
# Nref: nombre d'intervalles de la discrétisation pour le calcul de référence
#
# On considèrera dans la suite le résultat de ce calcul comme une suffisamment 
# bonne approximation des valeurs propres et vecteurs propres du problèm continu.
Nref = 2048;


## Construction de la matrice associée à la forme bilinéaire a(.,.)
Cref = Cmat0(Nref);
Kref = getMatdxdx(Cref,Nref); 

## Construction de la matrice associée au produit scalaire <.,.>_H
C0ref = np.ones(Nref); 
Mref = getMatmass(C0ref,Nref); 


## Affichage de la fonction c(x)
xvec = np.zeros(Nref); 
for i in range(0,Nref):
	xvec[i] = (i+0.5)/Nref; 

plt.plot(xvec, Cref); 
plt.xlabel('x'); 
plt.ylabel('c(x)'); 
plt.show(); 


## Résolution du problème aux valeurs propres généralisés
[eigvalref, eigvectref] = LS.eigh(Kref, Mref, type=1);

## Sauvegarde des résultats dans des fichiers .py qui seront lus par la suite
eigval10ref = eigvalref[0:9];
eigvect10ref = eigvectref[:,0:9];

np.save('eigvals_ref', eigval10ref); 
np.save('eigvects_ref', eigvect10ref);

print "lambdaref = "
print eigval10ref

## Affichage de la fonction u_{1,Nref}(x)
#xvec2 = np.zeros(Nref-1); 
#for i in range(0,Nref-1):
#	xvec2[i] = (i+1.0)/Nref; 
#
#plt.plot(xvec2, eigvect10ref[:,0].transpose()); 
#plt.xlabel('x'); 
#plt.ylabel('u_{1,Nref}(x)'); 
#plt.show(); 












